# Changelog
All releases of Etterna are listed in this file as well as links to files detailing all of the changes for each. All changes for each version apply in supplement to the ones below it. Changes are not in chronological order, only versions are.

## [0.68.1] - 2020-02-20 - Hotfix

Windows x64, Windows i386, and Mac installer release.
- Bugfixes for SSRNorm Preference and Midgrades.
- [Notes](.changelog/Release_0-68-1.md)

## [0.68.0] - 2020-02-17 - New Color Editor & Borderless Fullscreen

Windows x64, Windows i386, and Mac installer release.
- Color Editor rewritten, and borderless fullscreen added. Many small changes for stability.
- [Notes](.changelog/Release_0-68-0.md)

## [0.67.1] - 2019-12-23 - Hotfix

Windows x64, Windows i386, and Mac installer release.
- Chart Preview bugfixes, further Replay bugfixes, and an improvement to the Random Song picker.
- [Notes](.changelog/Release_0-67-1.md)

## [0.67.0] - 2019-12-16 - Til Death Translation Support, Replay Fixes, Practice Updates

Windows x64 and Windows i386 installer release.
- Most Replay bugs fixed, Chinese Til Death Translation added, and enhancements to Practice Mode to improve user experience.
- [Notes](.changelog/Release_0-67-0.md)

## [0.66.1] - 2019-06-13 - Hotfix

Windows x64, Windows i386, and Mac installer release.
- Bugfixes for various changes from the previous release.
- [Notes](.changelog/Release_0-66-1.md)

## [0.66.0] - 2019-06-03 - Codebase Restructure & Quality of Life Patch 2

Windows x64, Windows i386, and Mac installer release.
- Restructure of the Repository. Added Asset Picker. Cleaned up code & multiplayer.
- [Notes](.changelog/Release_0-66-0.md)
 
## [0.65.1] - 2019-03-10 - Quality of Life Patch

Windows x64, Windows i386, and Mac installer release. Linux tar available.
- Many bugfixes and performance improvements to mostly Practice Mode.
- [Notes](.changelog/Release_0-65-1.md)

## [0.65.0] - 2019-03-01 - Practice Mode

Windows x64 and Windows i386 installer release.
- Practice Mode, Audio Visualizer, and Common Pack Filtering in Multiplayer added. Many old Stepmania assets removed.
- [Notes](.changelog/Release_0-65-0.md)

## [0.64.0] - 2018-12-04 - Public Multiplayer

Windows x64, Windows i386, and Mac installer release.
- Multiplayer is now public and available from the client. 
- [Notes](.changelog/Release_0-64.md)

## [0.63.0] - 2018-11-23 - Performance Boost

Windows x64 and Windows i386 installer release. Mac zip included.
- Replay Watching is improved to use offset values for Taps when available. Various performance improvements.
- [Notes](.changelog/Release_0-63.md)

## [0.62.1] - 2018-11-14 - Hotfix

Windows x64, Windows i386, and Mac installer release.
- Bugfixes and Optimizations to Chart Preview & ScreenSelectMusic.
- [Notes](.changelog/Release_0-62-1.md)

## [0.62.0] - 2018-11-11 - Chart Preview

Windows x64 & i386 installer release only.
- Chart Preview added. CustomizeGameplay now has mouse support.
- [Notes](.changelog/Release_0-62-0.md)

## [0.61.1] - 2018-10-17 - 64bit D3D Crash Hotfix

Windows x64 installer release only.
- Release to fix crashing on 64 bit D3D.
- [Notes](.changelog/Release_0-61-1.md)

## [0.61.0] - 2018-10-12 - Replay Watching, Multithread Song Load, and 64bit

Windows x64, Windows i386, and Mac installer release.
- 64 bit version added. Replay Watching & Evaluation Viewing from Replay Data added. Osu Noteloader & Pack Downloader mirrors added.
- [Notes](.changelog/Release_0-61-0.md)

## [0.60.0] - 2018-08-18 - Online Integration & LuaJIT

Windows and Mac installer release. Multiplayer is functional but private, so the option is hidden in this release.
- Integration with EtternaOnline, Pack Downloader, and Song Tags added.
- [Notes](.changelog/Release_0-60.md)

## [0.57.1] - 2017-11-15 - Last Big MSD Update & Bug Fixes

Windows installer release. Due to merging, some features of this version and the previous one may be confused.
- Pasting from the clipboard added. MSD received its last update: Chordjacks replaced JackStamina.
- [Notes](.changelog/Release_0-57-1.md)

## [0.57.0] - 2017-11-11 - Discord Rich Presence

Windows installer release. This version was released as 2 separate installers, which are effectively the same.
- Discord Rich Presence added.
- [Notes](.changelog/Release_0-57-0.md)

## [0.56.2] - 2017-11-10 - Client Bugfixes & Previous Calculator Updates

Windows installer release.
- Custom Judge Windows & Rescoring added to Til Death. Boo Window is capped at 180ms minimum.
- [Notes](.changelog/Release_0-56-2.md)

## [0.56.2] - 2017-11-05 - Pre-release: Calculator Updates required for EtternaOnline

Windows, Mac, and Linux pre-release.
- MSD Calculator scaling capped at 97% now. Only Top Scores count in Player Rating, and only Chord Cohesion Off counts.
- [Notes](.changelog/Release_0-56-2-pre1.md)

## [0.56.1] - 2017-10-30 - Pre-release: Calculator Updates

Windows only installer pre-release.
- MSD Calculator improved by rating jacks more fairly.
- [Notes](.changelog/Release_0-56-1.md)

## [0.56.0] - 2017-10-17 - Pre-release: Calculator Updates

Windows, and Mac pre-release.
- MSD Calculator improved by distinguishing skillsets better.
- [Notes](.changelog/Release_0-56-0.md)

## [0.55.3] - 2017-10-12 - Hotfix 3: MP3 Sync Fix

Windows, Mac, and Linux release.
- More bugfixes to attempt to fix desync issues on MP3s.
- [Notes](.changelog/Release_0-55-3.md)

## [0.55.2] - 2017-10-03 - Hotfix 2: Weird Wifepercent Fix

Windows, Mac, and Linux release.
- More bugfixes and bandaids to previous hacks.
- [Notes](.changelog/Release_0-55-2.md)

## [0.55.1] - 2017-09-18 - Hotfix: Things We Didn't Notice

Windows, Mac, and Linux release.
- Support for rates up to 3.0x and various bug fixes.
- [Notes](.changelog/Release_0-55-1.md)

## [0.55.0] - 2017-09-08 - EtternaOnline, Chord Cohesion Off, and More

Windows, Mac, and Linux release.

This version coincided with the launch of [EtternaOnline](https://etternaonline.com/).
- Chord Cohesion Off is official. Goals & Playlists added. Gameplay is now fully customizeable. Etterna.xml format introduced.
- [Notes](.changelog/Release_0-55-0.md)

## [0.54.2] - 2017-03-19 - Unreleased Iteration

Source only unofficial release.
- Early work on CustomizeGameplay, Multiplayer, and Chord Cohesion off.
- [Notes](.changelog/Release_0-54-2.md)

## [0.54.1] - 2017-01-30 - Release Candidate

Windows installer pre-release.
- Release to fix a bug in Player Rating calculation.
- [Notes](.changelog/Release_0-54-1.md)

## [0.54.1] - 2017-01-29 - Pre-release: DP to Wife Conversion

Windows installer pre-release.
- DP to Wife conversion is enabled for each load. Mouse support on the MusicWheel is added. RestartGameplay button added.
- [Notes](.changelog/Release_0-54-1-pre1.md)

## [0.54.0] - 2017-01-24 - Official v0.54 Release

Windows installer release.
- Judge Conversion on the Evaluation Screen introduced.
- [Notes](.changelog/Release_0-54-0.md)

## [0.54.0] - 2017-01-21 - Pre-release 2: Replay Data Saving

Windows installer pre-release.
- Filter Tab for filtering Songs by Skillset & Replay Data writing introduced.
- [Notes](.changelog/Release_0-54-0-pre2.md)

## [0.54.0] - 2017-01-12 - Pre-release: More Specific Skillsets

Windows installer pre-release.
- Appveyor & Travis builds introduced. DivideByZero Noteskin variants added. Skillsets are split into more specific categories.
- [Notes](.changelog/Release_0-54-0-pre1.md)

## [0.53.1] - 2016-12-25 - Hotfix

Windows installer release.
- Update to fix Evaluation Screen crashing.
- [Notes](.changelog/Release_0-53-1.md)

## [0.53.0] - 2016-12-24 - Skillset Ratings

Windows installer release.
- DP to Wife conversion introduced (not enabled). Skillset Specific Ratings introduced (different from Score Specific Ratings).
- [Notes](.changelog/Release_0-53-0.md)

## [0.52.0] - 2016-12-14 - Song Favoriting

Windows installer release.
- Song Favoriting introduced in Etterna. Target Tracking introduced in Til Death. Internal judge rescoring algorithms introduced.
- [Notes](.changelog/Release_0-52.md)

## [0.51.0] - 2016-12-07 - Song Search

Windows installer release.
- Song Search introduced in Til Death. Moving gradually to Wife-based Grades.
- [Notes](.changelog/Release_0-51.md)

## [0.50.0] - 2016-12-04 - Public Beta Release - MSD & Wife

Windows installer release meant to be installed in its own clean directory.
- Mina Standardized Difficulty & Millisecond Scoring integrated into Etterna. Til Death Theme & Etterna Song Pack ships with the new installer.
- [Notes](.changelog/Release_0-50.md)

## [0.03.0] - 2016-09-09 - More FPS Improvements

Binary only release to replace Stepmania.exe.
- Frame Limiter, PitchRates Preferences and optimizations
- [Notes](.changelog/Release_0-03.md)

## [0.02.0] - 2016-08-31 - Early Experimental FPS Improvements

Binary only release to replace Stepmania.exe.
- Large FPS Improvements & optimizations
- [Notes](.changelog/Release_0-02.md)

## [0.01.0] - 2016-08-26 - Early Experimental Release

Binary only release to replace Stepmania.exe. Initial branch off of [Stepmania 5.0.12](../../tree/v5.0.12)
- Small experimental FPS improvements & bug fixes
- [Notes](.changelog/Release_0-01.md)
